%global PACKAGE             'boilerplate-for-c-and-gtk3'
%global PACKAGE_ID          'io.github.julianrichen.boilerplate'
%global PACKAGE_VERSION     '0.1.0'
%global PACKAGE_SUMMARY     'A boilerplate for quick GTK3 development in C'
%global PACKAGE_URL         'https://github.com/julianrichen/boilerplate-for-c-gtk3'
%global PACKAGE_DESCRIPTION ''

Name:           %{PACKAGE}
Version:        %{PACKAGE_VERSION}
Release:        1%{?dist}
Summary:        %{PACKAGE_SUMMARY}

License:        GPLv3+
URL:            %{PACKAGE_URL}
Source0:        %{url}/archive/%{version}.tar.gz

BuildRequires:  meson >= 0.36.0
BuildRequires:  pkgconfig
BuildRequires:  pkgconfig(glib-2.0)
BuildRequires:  pkgconfig(gtk+-3.0) >= 3.20.0
BuildRequires:  pkgconfig(libpeas-gtk-1.0)
BuildRequires:  gettext
BuildRequires:  desktop-file-utils
BuildRequires:  update-desktop-files
BuildRequires:  gtk-update-icon-cache
BuildRequires:  glib-compile-schemas
BuildRequires:  hicolor-icon-theme

%description
%{PACKAGE_DESCRIPTION}

%package devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%prep
%setup -q

%build
%meson
%meson_build

%install
%meson_install

%check
%meson_check
appstream-util validate-relax --noset $RPM_BUILD_ROOT%{_datadir}/%{PACKAGE_ID}.appdata.xml
desktop-file-validate  $RPM_BUILD_ROOT%{_datadir}/%{PACKAGE_ID}.desktop

%post

%postun
if [ $1 -eq 0 ]; then
    glib-compile-schemas %{_datadir}/glib-2.0/schemas >&/dev/null || :
fi

%posttrans
glib-compile-schemas %{_datadir}/glib-2.0/schemas >&/dev/null || :

%files -f %{name}.lang
%license LICENSE
%dir %{_libdir}/%{name}/plugins
%{_bindir}/%{name}
%{_libdir}/%{name}.so*
%{_libdir}/%{name}/plugins/*

%{_datadir}/appdata/%{PACKAGE_ID}.appdata.xml
%{_datadir}/applications/%{PACKAGE_ID}.desktop
%{_datadir}/glib-2.0/schemas/%{PACKAGE_ID}.gschema.xml
%{_datadir}/help/*/%{name}/*
%{_datadir}/icons/hicolor/*/apps/%{PACKAGE_ID}.png
%{_datadir}/icons/hicolor/scalable/apps/%{PACKAGE_ID}.svg
%{_datadir}/icons/hicolor/symbolic/apps/%{PACKAGE_ID}-symbolic.svg
%{_mandir}/man1/%{name}.1*

%files devel
%dir %{_includedir}/%{name}
%dir %{_datadir}/gtk-doc/
%dir %{_datadir}/gtk-doc/html/
%doc %{_datadir}/gtk-doc/html/%{name}/
%{_includedir}/%{name}/*
%{_libdir}/pkgconfig/*
%{_libdir}/*.so

%changelog
* Sun Jul 2 2017 Julian Richen <julian@richen.io>
- Initial package
